/*****************************************************
  symbols.h     
  128x64_functions.h   

      :
1)     .  massives.h

2)         massives.h    128x64_functions.h
    128x64_functions.h

3)    mass []= " ";

4)      i2c_and_TDA7313.lib.


 :
   /     1/0

)      ,         *tabstr
page_kolonka_CS1_CS2_SL_massiv_nmass(, ,  1,  2, ,     *tabstr,   )

)   .          ,      .
  . ,   ,   
putstr(  ,  1,  2, , ,  , )

 1  2   1,    0
     0  7
  0  63
  "" 0,     . ,  1,      

)  
LCD_clear( 1,  2)


*****************************************************/
/*   */
#define Up 32
#define Down 33
#define Left 17
#define Right 16
#define Menu 48
#define OK 59
#define Att 13
#define Off 12
#define Timer 42
#define Minus 21
#define Plus 22
#define Go_menu1 34
#define IN1 1
#define IN2 2
#define IN3 3
#define SBR 10
/*******************************************/







//     12864_functions
#define Power_ON  PORTB SET_B0;			//    .0 .1 -     
#define Power_OFF PORTB CLR_B0;			//      
#define TA2022_ON  PORTD SET_B5;		//    .2  2022
#define TA2022_OFF PORTD CLR_B5;		//    .2  2022
#define Displ_podsvetka_ON PORTB SET_B3	//   
#define Displ_podsvetka_OFF PORTB CLR_B3	//   
#define Keyboard_Light_ON PORTB SET_B1;	//   
#define Keyboard_Light_OFF  PORTB CLR_B1;	//   



#define SET_B4 |=(1<<4);
#define CLR_B4 &=~(1<<4);
#define CS_act  PORTB CLR_B4;	//  4  0 -  
#define CS_unact  PORTB SET_B4;


#include <mega32.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#include <peremennie_and_txt.h>
#include <ad7142regmap.h>
#include <spi.h>
#include <7142_functions.h>
#include <7142_config.h>
#include <DELAY.h>
#include <STRING.H>
#include <stdio.h>
#include <ds1307.h>

#include <i2c.h>


#asm                                        //    DS1307
   .equ __i2c_port=0x15 ;PORTC
   .equ __sda_bit=7
   .equ __scl_bit=6
#endasm
#include <i2c.h>
#include <controller_init.h>

#include <symbols.h>
#include <massives.h>
#include <128x64_functions.h>
#include <i2c_and_TDA7313.h>
#include <menu_otobr.h>
#include <RC5.h>
#include <menu_navigation.h>
#include <1307_functions.h>
#include <set_changes.h >
void treble_swich (void) {
if (treble<=7) {  //F3
com=112+treble;
 tda7313_write(com);}  //F3
if ((treble>7)&&(treble<=14)) {  //F4
com=134-treble;
 tda7313_write(com);
 }  //F4
}

void bass_swich (void) {
if (bass<=7) {  //F3
com=96+bass;
 tda7313_write(com);}  //F3
if ((bass>7)&&(bass<=14)) {  //F4
com=118-bass;
 tda7313_write(com);
 }  //F4
}


void set_parameters (void) {     // R1          

/************************************   5*******************************************/
if ((command_tx==20)&&(tek_menu==5)) {  //3
if ((rem_command==Plus)&& (volume_ogr>0)) {//A4
volume_ogr--;
command_tx=10;
displ_refresh=1;
goto n1;
}//A4
if ((rem_command==Minus)&& (volume_ogr<63)) {//A5
volume_ogr++;
command_tx=10;
displ_refresh=1;
goto n1;
}//A5
}//A3
 /****************************************************************************************************/
/************************************   6*******************************************/
if ((command_tx==20)&&(tek_menu==6)) {  //3
if ((rem_command==Plus)&& (volume_on_max>0)) {//A4
volume_on_max--;
command_tx=10;
displ_refresh=1;
goto n1;
}//A4
if ((rem_command==Minus)&& (volume_on_max<63)) {//A5
volume_on_max++;
command_tx=10;
displ_refresh=1;
goto n1;
}//A5
}//A3
 /****************************************************************************************************/
 /************************************   7*******************************************/
if ((command_tx==20)&&(tek_menu==7)) {  //3
if ((rem_command==Plus)&& (att>0)) {//A4
att--;
command_tx=10;
displ_refresh=1;
goto n1;
}//A4
if ((rem_command==Minus)&& (att<31)) {//A5
att++;
command_tx=10;
displ_refresh=1;
goto n1;
}//A5
}//A3
 /****************************************************************************************************/
  /************************************   8*******************************************/
if ((command_tx==20)&&(tek_menu==8)&&(tog_ch!=toggle)) {  //3
Refr4=1;          //    

switch ( tek_vhod) {                                                     //   loudness      
case 1: loudness=loudness1;   break;
case 2: loudness=loudness2;   break;
case 3: loudness=loudness3;   break;
};

if ((rem_command==Plus)&& (loudness<3)) {//A4             tek_vhod=1
loudness++;                       //  
if (tek_vhod==1) { //AA          1           
switch ( loudness) {    //(8)              loudness ,   0   
case 1:   tda7313_write(80);  loudness1=loudness;  displ_refresh=1;  break;          //    7313        
case 2:   tda7313_write(72);  loudness1=loudness;  displ_refresh=1;  break;
case 3:   tda7313_write(64);  loudness1=loudness;  displ_refresh=1;  break;
};   //(8)
} //AA
if (tek_vhod==2) { //AA          2           
switch ( loudness) {    //(8)              loudness ,   0   
case 1:   tda7313_write(81); loudness2=loudness;  displ_refresh=1;  break;
case 2:   tda7313_write(73); loudness2=loudness;  displ_refresh=1;  break;
case 3:   tda7313_write(65); loudness2=loudness;  displ_refresh=1;  break;
};   //(8)
} //AA
if (tek_vhod==3) { //AA          3           
switch ( loudness) {    //(8)              loudness ,   0   
case 1:   tda7313_write(82); loudness3=loudness;  displ_refresh=1;  break;
case 2:   tda7313_write(74); loudness3=loudness;  displ_refresh=1; break;
case 3:   tda7313_write(66); loudness3=loudness;  displ_refresh=1;  break;
};   //(8)
} //AA
tog_ch=toggle;
command_tx=10;
goto n1;
}//A4

if ((rem_command==Minus)&& (loudness>0)&&(tog_ch!=toggle)) {//A5
loudness--;
if (tek_vhod==1) { //AA          1           
switch ( loudness) {    //(8)              loudness ,   3   
case 0:   tda7313_write(88); loudness1=loudness; displ_refresh=1;  break;
case 1:   tda7313_write(80); loudness1=loudness; displ_refresh=1;  break;
case 2:   tda7313_write(72); loudness1=loudness; displ_refresh=1;  break;
};   //(8)
} //AA
if (tek_vhod==2) { //AA          2           
switch ( loudness) {    //(8)              loudness ,   3   
case 0:   tda7313_write(89); loudness2=loudness; displ_refresh=1;  break;
case 1:   tda7313_write(81); loudness2=loudness; displ_refresh=1;  break;
case 2:   tda7313_write(73); loudness2=loudness; displ_refresh=1;  break;
};   //(8)
} //AA
if (tek_vhod==3) { //AA          3           
switch ( loudness) {    //(8)              loudness ,   3   
case 0:   tda7313_write(90); loudness3=loudness; displ_refresh=1;  break;
case 1:   tda7313_write(82); loudness3=loudness; displ_refresh=1;  break;
case 2:   tda7313_write(74); loudness3=loudness; displ_refresh=1;  break;
};   //(8)
} //AA
tog_ch=toggle;
command_tx=10;
goto n1;
}//A5
}//A3
 /****************************************************************************************************/
   /************************************   9*******************************************/
if ((command_tx==20)&&(tek_menu==9)) {      //F1          -  


switch ( tek_vhod) {
case 1:  treble=treble1;   break;
case 2:  treble=treble2;   break;
case 3:  treble=treble3;  break;
};


if ((rem_command==Plus)&&(treble<14)&&(tog_ch!=toggle)) {//F2   " "     ,     
command_tx=10;   //       
tog_ch=toggle; //  ,        
treble++;          //  

switch ( tek_vhod) {                    //          
case 1:  treble1=treble;   break;
case 2:  treble2=treble;   break;
case 3:  treble3=treble;  break;
};

displ_refresh=1;

//      7313
treble_swich ();
 goto n1;
 }//F2

if ((rem_command==Minus)&&(treble>0)&&(tog_ch!=toggle)) {//F6
command_tx=10;   //       
tog_ch=toggle; //  ,        
treble--;          //  

switch ( tek_vhod) {                    //          
case 1:  treble1=treble;   break;
case 2:  treble2=treble;   break;
case 3:  treble3=treble;  break;
};

displ_refresh=1;

//      7313
treble_swich ();
 goto n1;
}//F6
} //F1


 /****************************************************************************************************/
   /************************************   10*******************************************/
if ((command_tx==20)&&(tek_menu==10)) {      //Z1         -  

switch ( tek_vhod) {
case 1:  bass=bass1;   break;
case 2:  bass=bass2;   break;
case 3:  bass=bass3;  break;
};


if ((rem_command==Plus)&&(bass<14)&&(tog_ch!=toggle)) {//F2   " "     ,     
command_tx=10;   //       
tog_ch=toggle; //  ,        
bass++;          //  

switch ( tek_vhod) {                    //          
case 1:   bass1= bass;   break;
case 2:   bass2= bass;   break;
case 3:   bass3= bass;  break;
};

displ_refresh=1;
//      7313
bass_swich ();
 goto n1;
 }//F2
if ((rem_command==Minus)&&(bass>0)&&(tog_ch!=toggle)) {//F8
command_tx=10;   //       
tog_ch=toggle; //  ,        
bass--;          //  

switch ( tek_vhod) {                    //          
case 1:   bass1= bass;   break;
case 2:   bass2= bass;   break;
case 3:   bass3= bass;  break;
};

displ_refresh=1;
//      7313
bass_swich ();
 goto n1;
 }//F8
}//Z1

  /****************************************************************************************************/




 /************************************   11*******************************************/
if ((command_tx==20)&&(tek_menu==11)&&(tog_ch!=toggle)) {  //3
if ((rem_command==Plus)&& (date<31)) {//A4
date++;
displ_refresh=1;
rtc_set_date(date,mounth,year) ;
command_tx=10;
tog_ch=toggle;
}//A4
if ((rem_command==Minus)&& (date>1)) {//A4
date--;
displ_refresh=1;
rtc_set_date(date,mounth,year) ;
command_tx=10;
tog_ch=toggle;
}//A4
goto n1;
}//A3
 /****************************************************************************************************/

  /************************************   12*******************************************/
if ((command_tx==20)&&(tek_menu==12)&&(tog_ch!=toggle)) {  //3
if ((rem_command==Plus)&& (mounth<12)) {//A4
mounth++;
displ_refresh=1;
rtc_set_date(date,mounth,year) ;
command_tx=10;
tog_ch=toggle;
}//A4
if ((rem_command==Minus)&& (mounth>1)) {//A4
mounth--;
displ_refresh=1;
rtc_set_date(date,mounth,year) ;
command_tx=10;
tog_ch=toggle;
}//A4
goto n1;
}//A3
 /****************************************************************************************************/

   /************************************   13*******************************************/
if ((command_tx==20)&&(tek_menu==13)&&(tog_ch!=toggle)) {  //3
if ((rem_command==Plus)&& (year<55)) {//A4
year++;
displ_refresh=1;
rtc_set_date(date,mounth,year) ;
command_tx=10;
tog_ch=toggle;
}//A4
if ((rem_command==Minus)&& (year>8)) {//A4
year--;
displ_refresh=1;
rtc_set_date(date,mounth,year) ;
command_tx=10;
tog_ch=toggle;
}//A4
goto n1;
}//A3
 /****************************************************************************************************/
   /************************************   14*******************************************/
if ((command_tx==20)&&(tek_menu==14)&&(tog_ch!=toggle)) {  //3
if ((rem_command==Plus)&& (h<24)) {//A4
h++;
displ_refresh=1;
if (h==24) {h=0;}
rtc_set_time(h,m,s);
command_tx=10;
tog_ch=toggle;
hour=h;
min=m;
}//A4

if ((rem_command==Minus)&& (h==0)) {h=23; displ_refresh=1;  rtc_set_time(h,m,s); hour=h;  min=m; command_tx=10; tog_ch=toggle;  goto n1;}

if ((rem_command==Minus)&& (h>0)) {//A4
h--;
displ_refresh=1;
rtc_set_time(h,m,s);
command_tx=10;
tog_ch=toggle;
hour=h;
min=m;
}//A4
goto n1;
}//A3
 /****************************************************************************************************/

   /************************************   15*******************************************/
if ((command_tx==20)&&(tek_menu==15)&&(tog_ch!=toggle)) {  //3
if ((rem_command==Plus)&& (m<60)) {//A4
m++;
displ_refresh=1;
if (m==60) {m=0;}
rtc_set_time(h,m,s);
command_tx=10;
tog_ch=toggle;
hour=h;
min=m;
}//A4

if ((rem_command==Minus)&& (m==0)) {m=59; rtc_set_time(h,m,s); hour=h;  min=m; command_tx=10; tog_ch=toggle;  goto n1;}

if ((rem_command==Minus)&& (m>0)) {//A4
m--;
displ_refresh=1;
rtc_set_time(h,m,s);
command_tx=10;
tog_ch=toggle;
hour=h;
min=m;
}//A4
goto n1;
}//A3
 /****************************************************************************************************/

    /************************************   16*******************************************/
if ((command_tx==20)&&(tek_menu==16)&&(tog_ch!=toggle)) {  //3
if ((rem_command==Plus)&& (s<60)) {//A4
s++;
displ_refresh=1;
if (s==60) {s=0;}
rtc_set_time(h,m,s);
command_tx=10;
tog_ch=toggle;
hour=h;
min=m;
}//A4

if ((rem_command==Minus)&& (s==0)) {s=59; rtc_set_time(h,m,s); hour=h;  min=m; command_tx=10; tog_ch=toggle;  goto n1;}

if ((rem_command==Minus)&& (s>0)) {//A4
s--;
displ_refresh=1;
rtc_set_time(h,m,s);
command_tx=10;
tog_ch=toggle;
hour=h;
min=m;
}//A4
goto n1;
}//A3
 /****************************************************************************************************/




    /************************************   19*******************************************/
if ((command_tx==20)&&(tek_menu==19))  {  //Q1
if (rem_command==Plus) {//A4
hour_on++;
displ_refresh=1;
if (hour_on>=24)  {hour_on=0;}
command_tx=10;
goto n1;
}//A4
 if ((rem_command==Minus)&&(hour_on==0)) {hour_on=23; command_tx=10; displ_refresh=1;  goto n1;}
 if ((rem_command==Minus)&&(hour_on>0)) {//A5
hour_on--;
displ_refresh=1;
command_tx=10;
goto n1;
}//A5
} //Q1
/****************************************************************************************************/
    /************************************   20*******************************************/
if ((command_tx==20)&&(tek_menu==20))  {  //Q1
if (rem_command==Plus) {//A4
min_on ++;
displ_refresh=1;
if (min_on>=60)  {min_on=0;}
command_tx=10;
goto n1;
}//A4
 if ((rem_command==Minus)&&(min_on==0)) {min_on=59; command_tx=10; displ_refresh=1;  goto n1;}
 if ((rem_command==Minus)&&(min_on>=1)) {//A5
min_on--;
displ_refresh=1;
command_tx=10;
goto n1;
}//A5
} //Q1
/****************************************************************************************************/
    /************************************   22*******************************************/
if ((command_tx==20)&&(tek_menu==22))  {  //Q1
if (rem_command==Plus) {//A4
hour_off++;
displ_refresh=1;
if (hour_off>=24)  {hour_off=0;}
command_tx=10;
goto n1;
}//A4
 if ((rem_command==Minus)&&(hour_off==0)) {hour_off=23; command_tx=10; displ_refresh=1; goto n1;}
 if ((rem_command==Minus)&&(hour_off>0)) {//A5
hour_off--;
displ_refresh=1;
command_tx=10;
goto n1;
}//A5
} //Q1
/****************************************************************************************************/
    /************************************   23*******************************************/
if ((command_tx==20)&&(tek_menu==23))  {  //Q1
if (rem_command==Plus) {//A4
min_off++;
displ_refresh=1;
if (min_off>=60)  {min_off=0;}
command_tx=10;
goto n1;
}//A4
 if ((rem_command==Minus)&&(min_off==0)) {min_off=59; command_tx=10; displ_refresh=1; goto n1;}
 if ((rem_command==Minus)&&(min_off>0)) {//A5
min_off--;
displ_refresh=1;
command_tx=10;
goto n1;
}//A5
} //Q1
/****************************************************************************************************/
    /************************************   24*******************************************/
if ((command_tx==20)&&(tek_menu==24))  {  //Q1
if (rem_command==Plus) {//A4
hour_off++;
displ_refresh=1;
if (hour_off>=24)  {hour_off=0;}
command_tx=10;
goto n1;
}//A4
 if ((rem_command==Minus)&&(hour_off==0)) {hour_off=23; command_tx=10; displ_refresh=1; goto n1;}
 if ((rem_command==Minus)&&(hour_off>0)) {//A5
hour_off--;
displ_refresh=1;
command_tx=10;
goto n1;
}//A5
} //Q1
/****************************************************************************************************/
   /************************************   25*******************************************/
if ((command_tx==20)&&(tek_menu==25))  {  //Q1
if (rem_command==Plus) {//A4
min_off++;
displ_refresh=1;
if (min_off>=60)  {min_off=0;}
command_tx=10;
goto n1;
}//A4
 if ((rem_command==Minus)&&(min_off==0)) {min_off=59; command_tx=10; displ_refresh=1; goto n1;}
 if ((rem_command==Minus)&&(min_off>0)) {//A5
min_off--;
displ_refresh=1;
command_tx=10;
goto n1;
}//A5
} //Q1
/****************************************************************************************************/

    /************************************   27*******************************************/
if ((command_tx==20)&&(tek_menu==27))  {  //Q1
if (rem_command==Plus) {//A4
hour_on++;
displ_refresh=1;
if (hour_on>=24)  {hour_on=0;}
command_tx=10;
goto n1;
}//A4
 if ((rem_command==Minus)&&(hour_on==0)) {hour_on=23; command_tx=10; displ_refresh=1; goto n1;}
 if ((rem_command==Minus)&&(hour_on>0)) {//A5
hour_on--;
displ_refresh=1;
command_tx=10;
goto n1;
}//A5
} //Q1
/****************************************************************************************************/
    /************************************   28*******************************************/
if ((command_tx==20)&&(tek_menu==28))  {  //Q1
if (rem_command==Plus) {//A4
min_on++;
displ_refresh=1;
if (min_on>=60)  {min_on=0;}
command_tx=10;
goto n1;
}//A4
 if ((rem_command==Minus)&&(min_on==0)) {min_on=59; command_tx=10;displ_refresh=1; goto n1;}
 if ((rem_command==Minus)&&(min_on>0)) {//A5
min_on--;
displ_refresh=1;
command_tx=10;
goto n1;
}//A5
} //Q1
/****************************************************************************************************/
    /************************************   29*******************************************/
if ((command_tx==20)&&(tek_menu==29)&&(tog_ch!=toggle))  {  //Q1  valcoder_sens
if ((rem_command==Plus)&&(valcoder_sens<8)) {//A4
valcoder_sens++;
displ_refresh=1;
n_valc_imp=10-valcoder_sens;
tog_ch=toggle;
command_tx=10;
goto n1;
}//A4

if ((rem_command==Minus)&&(valcoder_sens>0)) {//A4
valcoder_sens--;
displ_refresh=1;
n_valc_imp=10-valcoder_sens;
tog_ch=toggle;
command_tx=10;
goto n1;
}//A4
} //Q1
/****************************************************************************************************/












 /************************************   63 *******************************************/
if ((command_tx==20)&&(tek_menu==63)&&(tog_ch!=toggle))  {  //Q1

if(rem_command==SBR) {dig1=0; dig2=0; dig3=0; dig4=0; dig5=0; d_count=0; adr_long=0; }; 	//    -     
if (d_count>5) {d_count=0;};		//   
if((rem_command>9)&&(rem_command!=OK)) {goto e;};


if ((rem_command>=0)&&(rem_command<=9)) {//A4            
switch (d_count) {
    case 0 : dig1=rem_command;  break;
    case 1 : dig2=rem_command;  break;
    case 2 : dig3=rem_command;  break;
    case 3 : dig4=rem_command;  break;
    case 4 : dig5=rem_command;  break;
    case 5 : adr_long=(long int) rem_command; d_count=0; goto k; break;
    };
d_count++;

}//A4

switch (d_count) {
    case 1 : adr_long=(long int)dig1; goto k;  break;
    case 2 : adr_long=(long int)dig1*10 + (long int)dig2; goto k;  break;
    case 3 : adr_long=(long int)dig1*100 + (long int)dig2*10 + (long int)dig3; goto k;  break;
    case 4 : adr_long=(long int)dig1*1000 + (long int)dig2*100 + (long int)dig3*10 + (long int)dig4; goto k;  break;
    case 5 : adr_long=(long int)dig1*10000 + (long int)dig2*1000 + (long int)dig3*100 + (long int)dig4*10 + (long int)dig5;  break;
    };


k:
if (rem_command==Plus) {adr_long++;};
if (rem_command==Minus) {adr_long--;};

if(adr_long>655 ) {adr_long=0;};			// 
//if((adr_long>=24)&&(adr_long<=65)) {adr_long=0;};		// 
//if((adr_long>=67)&&(adr_long<=2032)) {adr_long=0;};	// 


address_temp=(unsigned int)adr_long;		//    int,  -  


if (rem_command==OK) {
res_temp = read_from_AD7142_spi (address_temp);	//    
d_count=0;
};
displ_refresh=1;
tog_ch=toggle;
command_tx=10;
goto n1;


e:
} //Q1
/****************************************************************************************************/




 /************************************   64 *******************************************/
if ((command_tx==20)&&(tek_menu==64)&&(tog_ch!=toggle))  {  //Q1

if(rem_command==SBR) {dig1=0; dig2=0; dig3=0; dig4=0; dig5=0; d_count=0; res_long=0; }; 	//    -     
if (d_count>5) {d_count=0;};		//   
if((rem_command>9)&&(rem_command!=OK)) {goto f;};

if ((rem_command>=0)&&(rem_command<=9)) {//A4            
switch (d_count) {
    case 0 : dig1=rem_command;  break;
    case 1 : dig2=rem_command;  break;
    case 2 : dig3=rem_command;  break;
    case 3 : dig4=rem_command;  break;
    case 4 : dig5=rem_command;  break;
    case 5 : res_long=(long int) rem_command; d_count=0; goto g; break;
    };
d_count++;

}//A4

switch (d_count) {
    case 1 : res_long=(long int)dig1; goto g;  break;
    case 2 : res_long=(long int)dig1*10 + (long int)dig2; goto g;  break;
    case 3 : res_long=(long int)dig1*100 + (long int)dig2*10 + (long int)dig3; goto g;  break;
    case 4 : res_long=(long int)dig1*1000 + (long int)dig2*100 + (long int)dig3*10 + (long int)dig4; goto g;  break;
    case 5 : res_long=(long int)dig1*10000 + (long int)dig2*1000 + (long int)dig3*100 + (long int)dig4*10 + (long int)dig5;  break;
    };


g:

if (rem_command==Plus) {res_long++;};
if (rem_command==Minus) {res_long--;};
if(res_long>65535) {res_long=0;};
res_temp=(unsigned int)res_long;		//    int


if (rem_command==OK) {
write_to_AD7142_spi(address_temp,res_temp);//  ,       
d_count=0;
if ((address_temp>=0)&&(address_temp<=7)) {AD7142_Config [address_temp]=res_temp;};//    
if ((address_temp>=128)&&(address_temp<=223)) {AD7142_Config [(address_temp-120)]=res_temp;};//    

};



displ_refresh=1;
tog_ch=toggle;
command_tx=10;
goto n1;


f:
} //Q1
/****************************************************************************************************/













/************************************   31  46 ****************************************Minus***/
if ((command_tx==20)&&(tog_ch!=toggle)&&(tek_menu==31))  {  //Q1
if(rem_command==SBR) {dig1=0; dig2=0; dig3=0; dig4=0; dig5=0; d_count=0; };
if (d_count>2) {d_count=0;};		//   

if ((rem_command>=0)&&(rem_command<=9)) {//A4            
switch (d_count) {
    case 0 : dig1=rem_command;  break;
    case 1 : dig2=rem_command;  break;
    case 2 : stage_temp=(unsigned  int) rem_command; d_count=0; goto u; break;
    };
d_count++;

}//A4



switch (d_count) {
    case 1 : stage_temp=(unsigned  int)dig1; goto u;  break;
    case 2 : stage_temp=(unsigned  int)dig1*10 + (unsigned  int)dig2; break;
 };
u:
if (rem_command==Plus) {stage_temp++;};
if (rem_command==Minus) {stage_temp--;};
if (stage_temp>11) {stage_temp=0;};

if (rem_command==OK) {stage = stage_temp;};



displ_refresh=1;
tog_ch=toggle;
command_tx=10;


} //Q1
/****************************************************************************************************/

/************************************   31  46 *******************************************/
if ((command_tx==20)&&(tog_ch!=toggle)&&(tek_menu==46))  {  //Q1
if(rem_command==SBR) {dig1=0; dig2=0; dig3=0; dig4=0; dig5=0; d_count=0; };
if (d_count>2) {d_count=0;};		//   

if ((rem_command>=0)&&(rem_command<=9)) {//A4            
switch (d_count) {
    case 0 : dig1=rem_command;  break;
    case 1 : dig2=rem_command;  break;
    case 2 : stage_temp=(unsigned  int) rem_command; d_count=0; goto u1; break;
    };
d_count++;

}//A4



switch (d_count) {
    case 1 : stage_temp=(unsigned  int)dig1; goto u;  break;
    case 2 : stage_temp=(unsigned  int)dig1*10 + (unsigned  int)dig2; break;
 };
u1:
if (rem_command==Plus) {stage_temp++;};
if (rem_command==Minus) {stage_temp--;};
if (stage_temp>11) {stage_temp=0;};

if (rem_command==OK) {stage = stage_temp;};



displ_refresh=1;
tog_ch=toggle;
command_tx=10;


} //Q1
/****************************************************************************************************/
















n1:
}   // R1
#include <TDA_7313_control.h> set_changes.h
#include <amp_init_on_off.h >
void system_init (void) {  // E1         
if (first_run!=25) {                 // E2
displ_refresh=1;
hour_on=0;
min_on = 0;
volume_ogr=30;
valcoder_sens=5;                        // 
n_valc_imp=10-valcoder_sens;  //   .  
save_volume = 44;                       //   -55,      7313 
volume_on_max=30;
tek_menu=0; 			//  0
loudness=0;                                 // 0 
loudness1=0;                                 // 0 
loudness2=0;                                 // 0 
loudness3=0;                                 // 0 

tek_vhod=1;                                //   1
att=25;                                           //  31,25    
treble=7;                                      //0 
treble1=7;                                      //0 
treble2=7;                                      //0 
treble3=7;                                      //0 

bass=7;                                          //0 
bass1=7;                                          //0 
bass2=7;                                          //0 
bass3=7;                                          //0 

tog_ch=0;
amp_on_act=0;						//         1 - 
amp_off_act=0;						//      1 - 
system_on=0;						//  0   

DS=12;                                                                          //    1307
first_run=25;

} // E2
}// E1

void amplifier_on (void) { //U1        
if ((system_on==0)&&(command_tx==20)&&(rem_command==Off)&&(tog_ch!=toggle)) {  //U2         ,        12    1  ,   
system_on=1;    //    
Refr4=1  ;


if (volume_on_max>=63) {volume_on_max=30;};
if (volume_ogr>=63) {volume_ogr=30;};
Power_ON        //              
//    !!!      ,       tda_control,      .   
Display_ON();        // ,      
LCD_init();            //   
LCD_clear();   //    
delay_ms(2000);   //        

 if (loudness1>=4)  {loudness1=0;}; //   
 if (loudness2>=4)  {loudness2=0;};
 if (loudness3>=4)  {loudness3=0;};
 if (save_volume>=64) {save_volume=44;}
 if (volume_on_max>=64) {volume_on_max=44;}

amp_on_act=0;



/////////////////////////////////////////////////////////////     7313   
tek_menu=0;  //     tda_control.     command_tx=20   
switch (tek_vhod) {    //c        ,    
case 1:  rem_command=IN1;  break;             //          tda_control
case 2:  rem_command=IN2;  break;
case 3:  rem_command=IN3;  break;
};
 tda_control ();              //            loudness ,          ,       
/////////////////////////////////////////////////////////////////////////// 


if (save_volume>=volume_on_max) {    //U3                    .  , 
volume= save_volume; tda7313_write(volume);     //   .   
}//U3
else { volume=volume_on_max; tda7313_write(volume);   }; // ,       


Displ_podsvetka_ON  //  
 Keyboard_Light_ON //  
 TA2022_ON  // 
}//U2
}//U1
   /////////////////////////////////////////////            1307

void amplifier_off(void) {  //R1       
if ((system_on==1)&&(command_tx==20)&&(rem_command==Off)&&(tog_ch!=toggle)) {  //R2
TA2022_OFF      //  
 system_on=0;    //                  


amp_off_act=0; //  




 //     
 if (volume>=volume_on_max) {             //         , 
save_volume=volume;                                //    
 }
 else {save_volume=volume_on_max;};
  LCD_clear();
 Display_OFF();
 Displ_podsvetka_OFF
 Keyboard_Light_OFF
 delay_ms(500);
 Power_OFF
 tog_ch=toggle;
 command_tx=10;
}//R2
} //R1


void auto_ON (void) {  //L1     min_on=0, hour_on=0;
if (amp_on_act==1){    //L2        //         
if ((hour_on==hour)&&(min_on==min)&&(system_on==0)){   //L3          ,    
command_tx=20;                                                                                                             //      
rem_command=Off;
tog_ch=1;
toggle=0;
amp_on_act=0; //  
 } //L3
}  //L2
} //L1

void auto_OFF (void) { //U1
if ((amp_off_act==1)&&(tek_menu<17)){  //U2          
if ((hour_off==hour)&&(min_off==min)&&(system_on==1)){   //U3          ,    
command_tx=20;                                                                                                             //      
rem_command=Off;
tog_ch=1;
toggle=0;
amp_off_act=0; //  
 } //U3



} //U2
}//U1
#include <valcoder_functions.h >
void valcoder (void) {

if (PIND.4==0) {                   // S1      .  ,   
valcoder_PLUS ++;                //    
valcoder_MINUS=0;              //  .         -

if ((valcoder_PLUS== n_valc_imp)&&(tek_menu==0)) {             // K1            0
valcoder_PLUS=0;   //  
command_tx=20;                                                                                                             //       +
rem_command=Right;
displ_refresh=1;
timer=0;        //       
} // K1


if ((valcoder_PLUS== n_valc_imp)&&(tek_menu!=0)) {	// K2             0
valcoder_PLUS=0;								//  
command_tx=20;								//      Plus
rem_command=Plus;
displ_refresh=1;
tog_ch=1;
toggle=0;
timer=0;        //       
} // K2
}// S1



if (PIND.4==1) {  // S2
valcoder_MINUS ++;
valcoder_PLUS=0;

if ((valcoder_MINUS== n_valc_imp)&&(tek_menu==0)) {             // K3            0
valcoder_MINUS=0;   //  
command_tx=20;                                                                                                             //       -
rem_command=Left;
displ_refresh=1;
timer=0;        //       
} // K3

if ((valcoder_MINUS== n_valc_imp)&&(tek_menu!=0)) {             // K4             0
valcoder_MINUS=0;   //  
command_tx=20;                                                                                                             //      Minus
rem_command=Minus;
displ_refresh=1;
tog_ch=1;
toggle=0;
timer=0;        //       
} // K4
}   // S2

}


//   7142
interrupt [EXT_INT2] void ext_int2_isr(void)
{
#asm ("cli");
SLLI	= read_from_AD7142_spi (8);		//Stage low limit int			 8
SHLI	= read_from_AD7142_spi (9);		//Stage hight limit int		 9
SCLI	= read_from_AD7142_spi (10);	//Stage complete limit int		 10


	if (   ((SHLI & 0x0001) != 0x0000) && ((SLLI& 0x0001) == 0x0000) && (EnableRecalAgain==1))
	{
		//These 2 variables are used to run the re-calibration only once
		EnableRecalAgain=0;
		EnableRecalCounter=0;
		// 
		temp=read_from_AD7142_spi (2);	//  2 AMB_COMP_CTRL0
		temp|=0x4000;				//   14 
		 write_to_AD7142_spi(2, temp);	//   AD7142

		//Read back
		do
		{temp=read_from_AD7142_spi (2);}	//  2
		while((temp & 0x4000) == 0x4000);
	}

if (EnableRecalCounter<4 && EnableRecalAgain==0) {EnableRecalCounter++;};

if (EnableRecalCounter==3 && EnableRecalAgain==0) {EnableRecalAgain=1;};


if (m1==0) {Keyboard_Light_ON;m1=1; goto w; };
if (m1==1) {Keyboard_Light_OFF;m1=0; };
w:
rem_command = Right;
command_tx=20;
#asm("sei")
}



//    0  TSOP
interrupt [EXT_INT0] void ext_int0_isr(void){ RC5_decoder();}


// Timer 0 overflow interrupt service routine    Rc5
interrupt [TIM0_OVF] void timer0_ovf_isr(void){
char i = 0;			// 
TCCR0 = 0x00;		// 
TCNT0 = 0x00;		// 
counter = 0;		// 
cnt_bit = 0;			//   
for (i=0; i<14; i++) code[i]=0; //   
}


// External Interrupt 1 service routine   
interrupt [EXT_INT1] void ext_int1_isr(void) {   valcoder ();}


// Timer 1 output compare A interrupt service routine     
interrupt [TIM1_COMPA] void timer1_compa_isr(void) {
#asm("cli")
Refr1=1; //    
if ((tek_menu>=31)&&(tek_menu<=69)) {timer=0;}//      7142,    
if ((tek_menu!=0)&&(tek_menu!=30)) {timer++;}                      //  ,       ...
if (timer>=40) {		//40     20 ,    2   
timer=0;			//  
tek_menu=0;		//      0
displ_refresh=1;		//   
Refr4=1;			//     1 
}

clock=1;  //   

if (att_on==1) {
//  
if (mig_att==0) {mig_att=1; goto e;}             //    0        mig_att     
if (mig_att==1) {mig_att=0;}
e:
}
#asm("sei")
}




void main(void)
{

init_controller ();

LCD_init();		//   
LCD_clear();	//    
i2c_init();		//  i2c
displ_refresh=1;
DS1307_init();	//     ,   1307       ,     DS  34
timer=0;		//        
AD7142_configure ();	// 7142
#asm("sei")



while (1)

{//while



if (clock==1) {vnutr_chasi (); clock=0; }              //     -             vnutr_chasi

auto_ON();
auto_OFF ();

if ( tek_menu!=30) {			//   ,   .       -  
amplifier_on();
amplifier_off();
system_init();				//        
}


if (system_on==1) {			//1   , :
menu_navi ();
if (tek_menu!=30) { //   
tda_control();

set_parameters ();
}
if (displ_refresh==1) {			//     -     
//LCD_clear();
display_menu(tek_menu);		//  
displ_refresh=0; }	   			//    

}     //1

}; //while
}









